EAPI EAPI_WEAK const Efl_Event_Description _EFL_PLAYER_EVENT_PLAYING_CHANGED =
   EFL_EVENT_DESCRIPTION("playing,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_PLAYER_EVENT_PAUSED_CHANGED =
   EFL_EVENT_DESCRIPTION("paused,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_PLAYER_EVENT_PLAYBACK_PROGRESS_CHANGED =
   EFL_EVENT_DESCRIPTION("playback_progress,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_PLAYER_EVENT_PLAYBACK_POSITION_CHANGED =
   EFL_EVENT_DESCRIPTION("playback_position,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_PLAYER_EVENT_PLAYBACK_REPEATED =
   EFL_EVENT_DESCRIPTION("playback,repeated");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_PLAYER_EVENT_PLAYBACK_FINISHED =
   EFL_EVENT_DESCRIPTION("playback,finished");

static Eina_Error
__eolian_efl_player_playing_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_player_playing_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_player_playing_set, Eina_Bool, EINA_FALSE /* false */, EFL_FUNC_CALL(playing), Eina_Bool playing);

static Eina_Value
__eolian_efl_player_playing_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_player_playing_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_player_playing_get, Eina_Bool, 0);

static Eina_Error
__eolian_efl_player_paused_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_player_paused_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_player_paused_set, Eina_Bool, EINA_FALSE /* false */, EFL_FUNC_CALL(paused), Eina_Bool paused);

static Eina_Value
__eolian_efl_player_paused_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_player_paused_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_player_paused_get, Eina_Bool, 0);

static Eina_Error
__eolian_efl_player_playback_position_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_player_playback_position_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_player_playback_position_set, EFL_FUNC_CALL(sec), double sec);

static Eina_Value
__eolian_efl_player_playback_position_get_reflect(const Eo *obj)
{
   double val = efl_player_playback_position_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_player_playback_position_get, double, 0);

static Eina_Error
__eolian_efl_player_playback_progress_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_player_playback_progress_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_player_playback_progress_set, EFL_FUNC_CALL(progress), double progress);

static Eina_Value
__eolian_efl_player_playback_progress_get_reflect(const Eo *obj)
{
   double val = efl_player_playback_progress_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_player_playback_progress_get, double, 0);

static Eina_Error
__eolian_efl_player_playback_speed_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_player_playback_speed_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_player_playback_speed_set, EFL_FUNC_CALL(speed), double speed);

static Eina_Value
__eolian_efl_player_playback_speed_get_reflect(const Eo *obj)
{
   double val = efl_player_playback_speed_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_player_playback_speed_get, double, 0);

static Eina_Error
__eolian_efl_player_autoplay_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_player_autoplay_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_player_autoplay_set, EFL_FUNC_CALL(autoplay), Eina_Bool autoplay);

static Eina_Value
__eolian_efl_player_autoplay_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_player_autoplay_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_player_autoplay_get, Eina_Bool, 0);

static Eina_Error
__eolian_efl_player_playback_loop_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_player_playback_loop_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_player_playback_loop_set, EFL_FUNC_CALL(looping), Eina_Bool looping);

static Eina_Value
__eolian_efl_player_playback_loop_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_player_playback_loop_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_player_playback_loop_get, Eina_Bool, 0);

static Eina_Bool
_efl_player_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_PLAYER_EXTRA_OPS
#define EFL_PLAYER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_player_playing_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playing_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_paused_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_paused_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_position_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_position_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_progress_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_progress_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_speed_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_speed_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_autoplay_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_autoplay_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_loop_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_player_playback_loop_get, NULL),
      EFL_PLAYER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"playing", __eolian_efl_player_playing_set_reflect, __eolian_efl_player_playing_get_reflect},
      {"paused", __eolian_efl_player_paused_set_reflect, __eolian_efl_player_paused_get_reflect},
      {"playback_position", __eolian_efl_player_playback_position_set_reflect, __eolian_efl_player_playback_position_get_reflect},
      {"playback_progress", __eolian_efl_player_playback_progress_set_reflect, __eolian_efl_player_playback_progress_get_reflect},
      {"playback_speed", __eolian_efl_player_playback_speed_set_reflect, __eolian_efl_player_playback_speed_get_reflect},
      {"autoplay", __eolian_efl_player_autoplay_set_reflect, __eolian_efl_player_autoplay_get_reflect},
      {"playback_loop", __eolian_efl_player_playback_loop_set_reflect, __eolian_efl_player_playback_loop_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_player_class_desc = {
   EO_VERSION,
   "Efl.Player",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_player_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_player_interface_get, &_efl_player_class_desc, NULL, NULL);
